import 'package:project_core/core/exception/AppException.dart';
import 'package:project_core/core/model/AppResponse.dart';
import 'package:project_core/core/model/error/ApiError.dart';
import 'package:rxdart/rxdart.dart';

typedef S Action<S>();

abstract class Bloc {
  void initialize() {}

  execute(BehaviorSubject controller, Action action, {String loading}) async {
    try {
      controller.add(AppResponse.loading());
      await action();
    } on AppException catch (e) {
      print(e);
      controller.add(AppResponse.error(e.toString()));
    } on BadRequestException catch (e) {
      print(e);
      ApiError error = ApiError.fromJson(e.data);
      controller.add(AppResponse.error(error));
    } catch(e){
      print(e);
      controller.add(AppResponse.error("Não conseguimos realizar sua requisição: " + e.toString()));
    }
  }

  void dispose();
}
